#!/usr/bin/env python
##################################################
# Gnuradio Python Flow Graph
# Title: Top Block
# Generated: Sat May  2 21:29:59 2015
##################################################

from PyQt4 import Qt
from PyQt4.QtCore import QObject, pyqtSlot
from gnuradio import analog
from gnuradio import blocks
from gnuradio import eng_notation
from gnuradio import gr
from gnuradio import qtgui
from gnuradio.eng_option import eng_option
from gnuradio.filter import firdes
from optparse import OptionParser
import PyQt4.Qwt5 as Qwt
import hpsdr
import sip
import sys

from distutils.version import StrictVersion
class top_block(gr.top_block, Qt.QWidget):

    def __init__(self):
        gr.top_block.__init__(self, "Top Block")
        Qt.QWidget.__init__(self)
        self.setWindowTitle("Top Block")
        try:
             self.setWindowIcon(Qt.QIcon.fromTheme('gnuradio-grc'))
        except:
             pass
        self.top_scroll_layout = Qt.QVBoxLayout()
        self.setLayout(self.top_scroll_layout)
        self.top_scroll = Qt.QScrollArea()
        self.top_scroll.setFrameStyle(Qt.QFrame.NoFrame)
        self.top_scroll_layout.addWidget(self.top_scroll)
        self.top_scroll.setWidgetResizable(True)
        self.top_widget = Qt.QWidget()
        self.top_scroll.setWidget(self.top_widget)
        self.top_layout = Qt.QVBoxLayout(self.top_widget)
        self.top_grid_layout = Qt.QGridLayout()
        self.top_layout.addLayout(self.top_grid_layout)

        self.settings = Qt.QSettings("GNU Radio", "top_block")
        self.restoreGeometry(self.settings.value("geometry").toByteArray())


        ##################################################
        # Variables
        ##################################################
        self.squelch = squelch = -150
        self.samp_rate = samp_rate = 48000
        self.drive = drive = 0
        self.TxF = TxF = 7000000
        self.Sideband = Sideband = -1
        self.RxPre = RxPre = 0
        self.RxF0 = RxF0 = 7150000
        self.PTT = PTT = 0
        self.FreqFine = FreqFine = 00000

        ##################################################
        # Blocks
        ##################################################
        self._drive_tool_bar = Qt.QToolBar(self)
        self._drive_tool_bar.addWidget(Qt.QLabel("drive"+": "))
        self._drive_line_edit = Qt.QLineEdit(str(self.drive))
        self._drive_tool_bar.addWidget(self._drive_line_edit)
        self._drive_line_edit.returnPressed.connect(
        	lambda: self.set_drive(eval(str(self._drive_line_edit.text().toAscii()))))
        self.top_grid_layout.addWidget(self._drive_tool_bar, 1,3,1,1)
        self._TxF_layout = Qt.QVBoxLayout()
        self._TxF_tool_bar = Qt.QToolBar(self)
        self._TxF_layout.addWidget(self._TxF_tool_bar)
        self._TxF_tool_bar.addWidget(Qt.QLabel("TxF"+": "))
        class qwt_counter_pyslot(Qwt.QwtCounter):
            def __init__(self, parent=None):
                Qwt.QwtCounter.__init__(self, parent)
            @pyqtSlot('double')
            def setValue(self, value):
                super(Qwt.QwtCounter, self).setValue(value)
        self._TxF_counter = qwt_counter_pyslot()
        self._TxF_counter.setRange(1000000, 54000000, 500000)
        self._TxF_counter.setNumButtons(2)
        self._TxF_counter.setValue(self.TxF)
        self._TxF_tool_bar.addWidget(self._TxF_counter)
        self._TxF_counter.valueChanged.connect(self.set_TxF)
        self._TxF_slider = Qwt.QwtSlider(None, Qt.Qt.Horizontal, Qwt.QwtSlider.BottomScale, Qwt.QwtSlider.BgSlot)
        self._TxF_slider.setRange(1000000, 54000000, 500000)
        self._TxF_slider.setValue(self.TxF)
        self._TxF_slider.setMinimumWidth(500)
        self._TxF_slider.valueChanged.connect(self.set_TxF)
        self._TxF_layout.addWidget(self._TxF_slider)
        self.top_layout.addLayout(self._TxF_layout)
        self._Sideband_options = (-1, 1, )
        self._Sideband_labels = ("Lower", "Upper", )
        self._Sideband_group_box = Qt.QGroupBox("Sideband")
        self._Sideband_box = Qt.QVBoxLayout()
        class variable_chooser_button_group(Qt.QButtonGroup):
            def __init__(self, parent=None):
                Qt.QButtonGroup.__init__(self, parent)
            @pyqtSlot(int)
            def updateButtonChecked(self, button_id):
                self.button(button_id).setChecked(True)
        self._Sideband_button_group = variable_chooser_button_group()
        self._Sideband_group_box.setLayout(self._Sideband_box)
        for i, label in enumerate(self._Sideband_labels):
        	radio_button = Qt.QRadioButton(label)
        	self._Sideband_box.addWidget(radio_button)
        	self._Sideband_button_group.addButton(radio_button, i)
        self._Sideband_callback = lambda i: Qt.QMetaObject.invokeMethod(self._Sideband_button_group, "updateButtonChecked", Qt.Q_ARG("int", self._Sideband_options.index(i)))
        self._Sideband_callback(self.Sideband)
        self._Sideband_button_group.buttonClicked[int].connect(
        	lambda i: self.set_Sideband(self._Sideband_options[i]))
        self.top_grid_layout.addWidget(self._Sideband_group_box, 1,2,1,1)
        self._RxPre_options = (0, 1, )
        self._RxPre_labels = ("Off", "On", )
        self._RxPre_tool_bar = Qt.QToolBar(self)
        self._RxPre_tool_bar.addWidget(Qt.QLabel("RxPre"+": "))
        self._RxPre_combo_box = Qt.QComboBox()
        self._RxPre_tool_bar.addWidget(self._RxPre_combo_box)
        for label in self._RxPre_labels: self._RxPre_combo_box.addItem(label)
        self._RxPre_callback = lambda i: Qt.QMetaObject.invokeMethod(self._RxPre_combo_box, "setCurrentIndex", Qt.Q_ARG("int", self._RxPre_options.index(i)))
        self._RxPre_callback(self.RxPre)
        self._RxPre_combo_box.currentIndexChanged.connect(
        	lambda i: self.set_RxPre(self._RxPre_options[i]))
        self.top_layout.addWidget(self._RxPre_tool_bar)
        self._RxF0_layout = Qt.QVBoxLayout()
        self._RxF0_tool_bar = Qt.QToolBar(self)
        self._RxF0_layout.addWidget(self._RxF0_tool_bar)
        self._RxF0_tool_bar.addWidget(Qt.QLabel("RxF0"+": "))
        class qwt_counter_pyslot(Qwt.QwtCounter):
            def __init__(self, parent=None):
                Qwt.QwtCounter.__init__(self, parent)
            @pyqtSlot('double')
            def setValue(self, value):
                super(Qwt.QwtCounter, self).setValue(value)
        self._RxF0_counter = qwt_counter_pyslot()
        self._RxF0_counter.setRange(500000, 54000000, 500000)
        self._RxF0_counter.setNumButtons(2)
        self._RxF0_counter.setValue(self.RxF0)
        self._RxF0_tool_bar.addWidget(self._RxF0_counter)
        self._RxF0_counter.valueChanged.connect(self.set_RxF0)
        self._RxF0_slider = Qwt.QwtSlider(None, Qt.Qt.Horizontal, Qwt.QwtSlider.BottomScale, Qwt.QwtSlider.BgSlot)
        self._RxF0_slider.setRange(500000, 54000000, 500000)
        self._RxF0_slider.setValue(self.RxF0)
        self._RxF0_slider.setMinimumWidth(500)
        self._RxF0_slider.valueChanged.connect(self.set_RxF0)
        self._RxF0_layout.addWidget(self._RxF0_slider)
        self.top_layout.addLayout(self._RxF0_layout)
        self._PTT_options = (0, 1, 2, )
        self._PTT_labels = ("Off", "Vox", "On", )
        self._PTT_group_box = Qt.QGroupBox("PTT")
        self._PTT_box = Qt.QVBoxLayout()
        class variable_chooser_button_group(Qt.QButtonGroup):
            def __init__(self, parent=None):
                Qt.QButtonGroup.__init__(self, parent)
            @pyqtSlot(int)
            def updateButtonChecked(self, button_id):
                self.button(button_id).setChecked(True)
        self._PTT_button_group = variable_chooser_button_group()
        self._PTT_group_box.setLayout(self._PTT_box)
        for i, label in enumerate(self._PTT_labels):
        	radio_button = Qt.QRadioButton(label)
        	self._PTT_box.addWidget(radio_button)
        	self._PTT_button_group.addButton(radio_button, i)
        self._PTT_callback = lambda i: Qt.QMetaObject.invokeMethod(self._PTT_button_group, "updateButtonChecked", Qt.Q_ARG("int", self._PTT_options.index(i)))
        self._PTT_callback(self.PTT)
        self._PTT_button_group.buttonClicked[int].connect(
        	lambda i: self.set_PTT(self._PTT_options[i]))
        self.top_grid_layout.addWidget(self._PTT_group_box, 1,1,1,1)
        self._FreqFine_layout = Qt.QVBoxLayout()
        self._FreqFine_tool_bar = Qt.QToolBar(self)
        self._FreqFine_layout.addWidget(self._FreqFine_tool_bar)
        self._FreqFine_tool_bar.addWidget(Qt.QLabel("FreqFine"+": "))
        class qwt_counter_pyslot(Qwt.QwtCounter):
            def __init__(self, parent=None):
                Qwt.QwtCounter.__init__(self, parent)
            @pyqtSlot('double')
            def setValue(self, value):
                super(Qwt.QwtCounter, self).setValue(value)
        self._FreqFine_counter = qwt_counter_pyslot()
        self._FreqFine_counter.setRange(000000, 500000, 500)
        self._FreqFine_counter.setNumButtons(2)
        self._FreqFine_counter.setValue(self.FreqFine)
        self._FreqFine_tool_bar.addWidget(self._FreqFine_counter)
        self._FreqFine_counter.valueChanged.connect(self.set_FreqFine)
        self._FreqFine_slider = Qwt.QwtSlider(None, Qt.Qt.Horizontal, Qwt.QwtSlider.BottomScale, Qwt.QwtSlider.BgSlot)
        self._FreqFine_slider.setRange(000000, 500000, 500)
        self._FreqFine_slider.setValue(self.FreqFine)
        self._FreqFine_slider.setMinimumWidth(500)
        self._FreqFine_slider.valueChanged.connect(self.set_FreqFine)
        self._FreqFine_layout.addWidget(self._FreqFine_slider)
        self.top_layout.addLayout(self._FreqFine_layout)
        self._squelch_layout = Qt.QVBoxLayout()
        self._squelch_tool_bar = Qt.QToolBar(self)
        self._squelch_layout.addWidget(self._squelch_tool_bar)
        self._squelch_tool_bar.addWidget(Qt.QLabel("squelch"+": "))
        class qwt_counter_pyslot(Qwt.QwtCounter):
            def __init__(self, parent=None):
                Qwt.QwtCounter.__init__(self, parent)
            @pyqtSlot('double')
            def setValue(self, value):
                super(Qwt.QwtCounter, self).setValue(value)
        self._squelch_counter = qwt_counter_pyslot()
        self._squelch_counter.setRange(-200, 0, 5)
        self._squelch_counter.setNumButtons(2)
        self._squelch_counter.setValue(self.squelch)
        self._squelch_tool_bar.addWidget(self._squelch_counter)
        self._squelch_counter.valueChanged.connect(self.set_squelch)
        self._squelch_slider = Qwt.QwtSlider(None, Qt.Qt.Horizontal, Qwt.QwtSlider.BottomScale, Qwt.QwtSlider.BgSlot)
        self._squelch_slider.setRange(-200, 0, 5)
        self._squelch_slider.setValue(self.squelch)
        self._squelch_slider.setMinimumWidth(500)
        self._squelch_slider.valueChanged.connect(self.set_squelch)
        self._squelch_layout.addWidget(self._squelch_slider)
        self.top_grid_layout.addLayout(self._squelch_layout, 1,4,1,1)
        self.qtgui_freq_sink_x_0 = qtgui.freq_sink_c(
        	1024, #size
        	firdes.WIN_BLACKMAN_hARRIS, #wintype
        	RxF0+Sideband*1500+FreqFine, #fc
        	384000, #bw
        	"QT GUI Plot", #name
        	1 #number of inputs
        )
        self.qtgui_freq_sink_x_0.set_update_time(0.10)
        self.qtgui_freq_sink_x_0.set_y_axis(-200, -50)
        self.qtgui_freq_sink_x_0.set_trigger_mode(qtgui.TRIG_MODE_FREE, 0.0, 0, "")
        self.qtgui_freq_sink_x_0.enable_autoscale(False)
        self.qtgui_freq_sink_x_0.enable_grid(True)
        self.qtgui_freq_sink_x_0.set_fft_average(1.0)
        
        if complex == type(float()):
          self.qtgui_freq_sink_x_0.set_plot_pos_half(not True)
        
        labels = ["PreFilter", "PostFilter", "", "", "",
                  "", "", "", "", ""]
        widths = [1, 1, 1, 1, 1,
                  1, 1, 1, 1, 1]
        colors = ["blue", "red", "green", "black", "cyan",
                  "magenta", "yellow", "dark red", "dark green", "dark blue"]
        alphas = [1.0, 1.0, 1.0, 1.0, 1.0,
                  1.0, 1.0, 1.0, 1.0, 1.0]
        for i in xrange(1):
            if len(labels[i]) == 0:
                self.qtgui_freq_sink_x_0.set_line_label(i, "Data {0}".format(i))
            else:
                self.qtgui_freq_sink_x_0.set_line_label(i, labels[i])
            self.qtgui_freq_sink_x_0.set_line_width(i, widths[i])
            self.qtgui_freq_sink_x_0.set_line_color(i, colors[i])
            self.qtgui_freq_sink_x_0.set_line_alpha(i, alphas[i])
        
        self._qtgui_freq_sink_x_0_win = sip.wrapinstance(self.qtgui_freq_sink_x_0.pyqwidget(), Qt.QWidget)
        self.top_layout.addWidget(self._qtgui_freq_sink_x_0_win)
        self.hpsdr_hermesNB_0 = hpsdr.hermesNB(RxF0+Sideband*1500+FreqFine, 200000, TxF+FreqFine, RxPre, PTT, 1, 1, drive, 384000, "eth0", "0xF0", 0xa0, 0, 0x00, 0x00, 0, 1)
        self.blocks_file_sink_0 = blocks.file_sink(gr.sizeof_gr_complex*1, "/home/jra/gr-projects/n8ur_2May2015_2130EDT_384k_7150kHz_raw_capture.bin", False)
        self.blocks_file_sink_0.set_unbuffered(False)
        self.analog_sig_source_x_1 = analog.sig_source_c(samp_rate, analog.GR_COS_WAVE, -1000, 0.95, 0)

        ##################################################
        # Connections
        ##################################################
        self.connect((self.analog_sig_source_x_1, 0), (self.hpsdr_hermesNB_0, 0))    
        self.connect((self.hpsdr_hermesNB_0, 0), (self.blocks_file_sink_0, 0))    
        self.connect((self.hpsdr_hermesNB_0, 0), (self.qtgui_freq_sink_x_0, 0))    

    def closeEvent(self, event):
        self.settings = Qt.QSettings("GNU Radio", "top_block")
        self.settings.setValue("geometry", self.saveGeometry())
        event.accept()

    def get_squelch(self):
        return self.squelch

    def set_squelch(self, squelch):
        self.squelch = squelch
        Qt.QMetaObject.invokeMethod(self._squelch_counter, "setValue", Qt.Q_ARG("double", self.squelch))
        Qt.QMetaObject.invokeMethod(self._squelch_slider, "setValue", Qt.Q_ARG("double", self.squelch))

    def get_samp_rate(self):
        return self.samp_rate

    def set_samp_rate(self, samp_rate):
        self.samp_rate = samp_rate
        self.analog_sig_source_x_1.set_sampling_freq(self.samp_rate)

    def get_drive(self):
        return self.drive

    def set_drive(self, drive):
        self.drive = drive
        Qt.QMetaObject.invokeMethod(self._drive_line_edit, "setText", Qt.Q_ARG("QString", repr(self.drive)))
        self.hpsdr_hermesNB_0.set_TxDrive(self.drive)

    def get_TxF(self):
        return self.TxF

    def set_TxF(self, TxF):
        self.TxF = TxF
        Qt.QMetaObject.invokeMethod(self._TxF_counter, "setValue", Qt.Q_ARG("double", self.TxF))
        Qt.QMetaObject.invokeMethod(self._TxF_slider, "setValue", Qt.Q_ARG("double", self.TxF))
        self.hpsdr_hermesNB_0.set_TransmitFrequency(self.TxF+self.FreqFine)

    def get_Sideband(self):
        return self.Sideband

    def set_Sideband(self, Sideband):
        self.Sideband = Sideband
        self._Sideband_callback(self.Sideband)
        self.hpsdr_hermesNB_0.set_Receive0Frequency(self.RxF0+self.Sideband*1500+self.FreqFine)
        self.qtgui_freq_sink_x_0.set_frequency_range(self.RxF0+self.Sideband*1500+self.FreqFine, 384000)

    def get_RxPre(self):
        return self.RxPre

    def set_RxPre(self, RxPre):
        self.RxPre = RxPre
        self._RxPre_callback(self.RxPre)
        self.hpsdr_hermesNB_0.set_RxPreamp(self.RxPre)

    def get_RxF0(self):
        return self.RxF0

    def set_RxF0(self, RxF0):
        self.RxF0 = RxF0
        self.hpsdr_hermesNB_0.set_Receive0Frequency(self.RxF0+self.Sideband*1500+self.FreqFine)
        Qt.QMetaObject.invokeMethod(self._RxF0_counter, "setValue", Qt.Q_ARG("double", self.RxF0))
        Qt.QMetaObject.invokeMethod(self._RxF0_slider, "setValue", Qt.Q_ARG("double", self.RxF0))
        self.qtgui_freq_sink_x_0.set_frequency_range(self.RxF0+self.Sideband*1500+self.FreqFine, 384000)

    def get_PTT(self):
        return self.PTT

    def set_PTT(self, PTT):
        self.PTT = PTT
        self._PTT_callback(self.PTT)
        self.hpsdr_hermesNB_0.set_PTTMode(self.PTT)

    def get_FreqFine(self):
        return self.FreqFine

    def set_FreqFine(self, FreqFine):
        self.FreqFine = FreqFine
        Qt.QMetaObject.invokeMethod(self._FreqFine_counter, "setValue", Qt.Q_ARG("double", self.FreqFine))
        Qt.QMetaObject.invokeMethod(self._FreqFine_slider, "setValue", Qt.Q_ARG("double", self.FreqFine))
        self.hpsdr_hermesNB_0.set_Receive0Frequency(self.RxF0+self.Sideband*1500+self.FreqFine)
        self.hpsdr_hermesNB_0.set_TransmitFrequency(self.TxF+self.FreqFine)
        self.qtgui_freq_sink_x_0.set_frequency_range(self.RxF0+self.Sideband*1500+self.FreqFine, 384000)

if __name__ == '__main__':
    import ctypes
    import sys
    if sys.platform.startswith('linux'):
        try:
            x11 = ctypes.cdll.LoadLibrary('libX11.so')
            x11.XInitThreads()
        except:
            print "Warning: failed to XInitThreads()"
    parser = OptionParser(option_class=eng_option, usage="%prog: [options]")
    (options, args) = parser.parse_args()
    if(StrictVersion(Qt.qVersion()) >= StrictVersion("4.5.0")):
        Qt.QApplication.setGraphicsSystem(gr.prefs().get_string('qtgui','style','raster'))
    qapp = Qt.QApplication(sys.argv)
    tb = top_block()
    tb.start()
    tb.show()
    def quitting():
        tb.stop()
        tb.wait()
    qapp.connect(qapp, Qt.SIGNAL("aboutToQuit()"), quitting)
    qapp.exec_()
    tb = None #to clean up Qt widgets
